<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <meta http-equiv="content-type" content="text/html;
      charset=windows-1252">
    <title>iFit: Loaders sub-library (iLoad)</title>
  </head>
  <body>
    <h1 style="text-align: center;"><a class="mozTocH1"
        name="mozTocId294096"></a>iFit: Loaders import sub-library</h1>
    <br>
    <ol id="mozToc">
      <!--mozToc h3 1 h4 2 h3 3 h4 4 h5 5 h6 6-->
      <li><a href="#mozTocId747249">iLoad the main file importer </a>
        <ol>
          <li><a href="#mozTocId52427">Distant files (http://, ...) </a></li>
          <li><a href="#mozTocId250466">Compressed files (.zip, ...) </a></li>
          <li><a href="#mozTocId338301">Internal anchor references
              (file#anchor) </a></li>
        </ol>
      </li>
      <li><a href="#mozTocId485865">Supported data formats (default)</a>
        <ol>
          <li><a href="#mozTocId876478">Legacy data formats (text,
              NetCDF, HDF, FITS, images, XML, CSV, ...) </a></li>
          <li><a href="#mozTocId361032">More specific data formats
              (neutrons and X-ray)</a></li>
          <li><a href="#mozTocId149630">Unsupported data formats: how to
              import them anyway ?</a></li>
        </ol>
      </li>
      <li><a href="#mozTocId519997">The import filters: customizing data
          formats (iLoad_ini) </a>
        <ol>
          <li><a href="#mozTocId56356">Reading and Writing the iLoad
              configuration</a></li>
          <li><a href="#mozTocId968211">iLoad configuration structure</a></li>
          <li><a href="#mozTocId120998">In short: procedure to add a new
              data format</a></li>
        </ol>
      </li>
    </ol>
    <br>
    <hr style="width: 100%; height: 2px;">
    <div style="text-align: center;">Commands we use in this page: <span
        style="font-style: italic;">iLoad(filename)<br>
        <b>See also</b>: <a href="Load.html">Load </a></span><a
        href="Load.html"><span style="font-style: italic;">(import) </span></a><span
        style="font-style: italic;"><a href="Load.html">data sets</a>, <a
          href="Save.html">Save (export) data sets</a> and <a
          href="iFunc.html#mozTocId2492">Save Models</a><br>
      </span> <br style="font-style: italic;">
    </div>
    The Loaders sub-library takes care to import a large set of file
    formats, and return them as a structure. This structure can then be
    converted into an <a href="iData.html">iData</a> object. There is a
    similar documentation for models in the <a
      href="iFunc.html#mozTocId2492">iFunc</a> page.<br>
    <h3><a class="mozTocH3" name="mozTocId747249"></a>iLoad: the main
      file importer<br>
    </h3>
    When a new file is imported into an iData object by means of e.g.<br>
    <div style="margin-left: 40px;">
      <pre>&gt;&gt; a = <span style="color: rgb(51, 102, 255);">iData</span>([ <span style="color: rgb(51, 102, 255);">ifitpath</span> <span style="color: rgb(204, 51, 204);">'Data/ILL_IN6.dat'</span> ]);<br>&gt;&gt; a = <span style="color: rgb(51, 102, 255);">load</span>(iData, <span style="color: rgb(204, 51, 204);">[ </span><span style="color: rgb(51, 102, 255);">ifitpath</span><span style="color: rgb(204, 51, 204);"> 'Data/ILL_IN6.dat' ]</span>);</pre>
    </div>
    the request for file access is sent transparently to the <span
      style="font-weight: bold;">iLoad</span> function. This latter
    performs the following operations:<br>
    <ol>
      <li>resolves the file name, and identifies directory importation,
        wildcards (*, ?), distant files with URLs (file://, ftp://,
        http://, https://), compressed files (zip, gzip, tar, compress)
        ;</li>
      <li>selects a list of possible file types from <span
          style="font-style: italic;">e.g.</span> file extension ;<br>
      </li>
      <li>searches for patterns in text headers to better determine file
        type ;<br>
      </li>
      <li>requests importation by all possible file types one after the
        other until one succeeds ;<br>
      </li>
      <li>formats the file content so that it is returned as a structure
        containing standard fields ;<br>
      </li>
      <li>executes remaining post-process scripts.<br>
      </li>
    </ol>
    The list of known file formats which can be imported is defined in
    the <span style="font-weight: bold;">iLoad_ini</span> file (see <a
      href="#mozTocId485865">below</a>), which is a list of format
    definitions with extension, patterns to search for, and post-process
    filters to run after importation. The order of these filters is
    important as they are parsed one after the other. A lower level of
    known formats is then added to the <span style="font-style:
      italic;">iLoad_ini </span>preferences, with more standard file
    formats (mainly those that Matlab knows <span style="font-style:
      italic;">de-facto</span>).<br>
    <br>
    A <a href="../Loaders/doc/uigetfiles.html">file selector</a>, which
    supports multiple file selection, may be used by issuing<br>
    <pre style="margin-left: 40px;">&gt;&gt; a = <span style="color: rgb(51, 102, 255);">iLoad</span>(<span style="color: rgb(204, 51, 204);">''</span>)</pre>
    The result of all this mechanics is that importation is fully
    transparent. The file type is determined automatically, imported and
    formatted accordingly. The resulting structure is then ready to be
    converted into an <a href="iData.html">iData</a> object.<br>
    <pre style="margin-left: 40px;">&gt;&gt; a = <span style="color: rgb(51, 102, 255);">iLoad</span>(filename); <span style="font-style: italic;">% this is a structure</span><br>&gt;&gt; a = <span style="color: rgb(51, 102, 255);">iData</span>(a);        <span style="font-style: italic;">% convert to iData object</span><br></pre>
    In the case where the automatic importation fails, it is possible to
    manually force one format specification to be used, from the <span
      style="font-style: italic;"><span style="color: rgb(51, 102,
        255);">iLoad</span> <span style="color: rgb(204, 51, 204);">formats</span></span>
    output<br>
    <pre style="margin-left: 40px;">&gt;&gt; <span style="color: rgb(51, 102, 255);">iLoad</span>(<span style="color: rgb(204, 51, 204);"></span><span style="color: rgb(204, 51, 204);">'formats'</span>)
...<br>HDF   read_hdf5/load_psi_RITA  HDF5<br>...<br>&gt;&gt; a = <span style="color: rgb(51, 102, 255);">iLoad</span>(filename, <span style="color: rgb(204, 51, 204);">'HDF5'</span>); <span style="font-style: italic;">% explicitly use HDF5 loader<br></span></pre>
    <h4><a class="mozTocH4" name="mozTocId52427"></a>Distant files
      (http://, ...)<br>
    </h4>
    The specified file names may include URL tags such as<br>
    <ul>
      <li><span style="font-weight: bold;">file://</span><span
          style="font-style: italic;">filename</span></li>
      <li><span style="font-weight: bold;">ftp://</span><span
          style="font-style: italic;">filename</span></li>
      <li><span style="font-weight: bold;">http://</span><span
          style="font-style: italic;">filename</span></li>
      <li><span style="font-weight: bold;">https://</span><span
          style="font-style: italic;">filename<br>
        </span></li>
    </ul>
    were the two latter cases first get a copy of the distant file
    (requires local write permission), and then import it. A valid
    Internet connection is then required, with proper Proxy settings if
    needed.<br>
    <h4><a class="mozTocH4" name="mozTocId250466"></a>Compressed files
      (.zip, .gz, .tar, .Z, ...)<br>
    </h4>
    Compressed files (ZIP, TAR, GZIP, Z) can also be imported directly,
    in which case they are first extracted locally (requires write
    permission), and then imported. This extraction mechanism is also
    available&nbsp; for distant file. Other compression methods are
    supported when installed on the system (<a
      href="https://lz4.github.io/lz4/">LZ4</a>, <a
      href="https://github.com/facebook/zstd">ZSTD</a>, <a
      href="https://tukaani.org/xz/">XZ</a>/<a
      href="https://jnovy.fedorapeople.org/pxz/">PXZ</a>/<a
      href="https://github.com/vasi/pixz">PiXZ</a>, <a
      href="https://zlib.net/pigz/">PiGZ</a>, <a
      href="https://www.sourceware.org/bzip2/">BZIP2</a>/<a
      href="https://github.com/ruanhuabin/pbzip2">PBZIP2</a>, <a
      href="https://www.lzop.org/">LZO</a>, <a
      href="https://github.com/google/brotli">BROTLI</a>, ...). When
    available, the extraction will be achieved in the shared memory
    (/dev/shm) for better performances.<br>
    <h4><a class="mozTocH4" name="mozTocId338301"></a>Internal anchor
      references (file#anchor)<br>
    </h4>
    The file name may end with an anchor reference using the '#'
    character, such as in <br>
    <br>
    <div style="margin-left: 40px;">'http://path/file.zip#Data'<br>
    </div>
    <br>
    In this case, the anchor is searched in the imported data, and only
    the corresponding matching elements are returned.
    <pre style="margin-left: 40px;"><span style="font-style: italic;"></span><span style="font-style: italic;"></span></pre>
    <h3><a class="mozTocH3" name="mozTocId485865"></a>Supported data
      formats (default)</h3>
    The Loaders sub-library comes with a large number of predefined
    import filters. These are tested one after the other, based on an
    initial filter selection using the file name extension and
    optionally pattern (words) recognition in file headers. <br>
    A compact list of all supported formats is shown with <br>
    <pre style="margin-left: 40px;">&gt;&gt; a = <span style="color: rgb(51, 102, 255);">iLoad</span>(<span style="color: rgb(204, 51, 204);">'formats'</span>);</pre>
    Some of these formats can be written back, providing a vast
    conversion capability (see the <a href="Save.html">Save</a> page).<br>
    The filters have been divided into two categories: those that
    directly use formats natively known by Matlab, and those that are
    more specific to neutron and X-ray communities (or other research
    areas).<br>
    <br>
    A set of example data files is available from the <a
      href="Load.html#mozTocId782211">Load</a> page and the <a
      href="../Data">Data</a> directory.<br>
    <h4><a class="mozTocH4" name="mozTocId876478"></a>Legacy data
      formats (text, NetCDF, HDF, FITS, images, XML, CSV, ...)<br>
    </h4>
    <span style="font-weight: bold;"> </span>
    <table style="text-align: left; width: 100%;" border="1"
      cellpadding="2" cellspacing="2">
      <tbody>
        <tr>
          <td style="vertical-align: top; background-color: rgb(255,
            204, 204); font-weight: bold; font-style: italic;">format
            (load)<br>
          </td>
          <td style="vertical-align: top; background-color: rgb(255,
            204, 204); font-weight: bold; font-style: italic;">Text/Binary<br>
          </td>
          <td style="vertical-align: top; background-color: rgb(255,
            204, 204); font-weight: bold; font-style: italic;">Description<br>
          </td>
          <td style="vertical-align: top; font-weight: bold;">iData/saveas<br>
            <a href="Save.html">Write</a><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'au'</span><br style="color:
              rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);">NeXT/SUN (.au) sound</span><br>
          </td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;">Sound format, initially from
            Sun/NeXT<br>
          </td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'avi'</span><br
              style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);">Audio/Video
              Interleaved</span><br style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);">multimedia container</span><br>
          </td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;">A video encoding format<br>
          </td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td valign="top"><span style="color: rgb(204, 51, 204);
              font-weight: bold;">'cdf' </span><span style="color:
              rgb(204, 51, 204);">CDF</span></td>
          <td valign="top"><br>
          </td>
          <td valign="top">The <a
              href="http://en.wikipedia.org/wiki/Common_Data_Format">CDF</a>
            format is a compact binary format. Such files can be
            edited/viewed with e.g <a
              href="http://www.opendx.org/about.html">OpenDX</a> and <a
              href="http://autoplot.org/">Autoplot</a>. It is <i>incompatible</i>
            with NetCDF. </td>
          <td valign="top">Yes<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'csv'<br>
            </span><span style="color: rgb(204, 51, 204);">Matlab<br>
              comma separated values</span><span style="color: rgb(204,
              51, 204); font-weight: bold;"><br>
            </span></td>
          <td style="vertical-align: top;">text<br>
          </td>
          <td style="vertical-align: top;">A file spreadsheet format.
            Can be viewed with any spreadsheet software (<a
              href="http://www.openoffice.org/">OpenOffice</a>, Excel, <a
              href="http://projects.gnome.org/gnumeric/">Gnumeric</a>)</td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="font-weight:
              bold; color: rgb(204, 51, 204);">'fig' </span><span
              style="color: rgb(204, 51, 204);">Matlab figure</span></td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;">The Matlab figure can also be
            opened with <span style="font-style: italic;">openfig(file)</span>,
            and then converted to iData with <span style="font-style:
              italic;">iData(gcf)</span>.<br>
          </td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'fits'</span><br
              style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);">FITS astronomical
              image format</span><br>
          </td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;">The <a
              href="http://fits.gsfc.nasa.gov/">FITS</a> format is a
            standard data format used in astronomy. Can be displayed
            with e.g. <a href="http://www.gimp.org/">GIMP</a>, <a
              href="http://www.trilon.com/xv/xv.html">xv</a>, <a
              href="http://autoplot.org/">Autoplot</a>.<br>
          </td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="font-weight:
              bold;"><span style="color: rgb(204, 51, 204);">'gif' 'bmp'
                'png' 'tiff' 'jpeg' 'ico'<br>
              </span></span></td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;">Standard image formats. View
            with e.g. <a href="http://www.gimp.org/">GIMP</a>, <a
              href="http://www.trilon.com/xv/xv.html">xv</a>, <a
              href="file:///home/farhi/dev/iFit/Docs/rsbweb.nih.gov/ij/">ImageJ</a>.</td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="font-weight:
              bold;"><span style="color: rgb(204, 51, 204);">'hdf4'<br>
              </span></span><span style="color: rgb(204, 51, 204);">HDF
              4<br>
              image</span><span style="font-weight: bold;"><span
                style="color: rgb(204, 51, 204);"><br>
              </span></span></td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;">The <a
              href="http://www.hdfgroup.org/">HDF4</a> format is a
            compact, binary storage format.&nbsp;<span
              style="font-weight: bold;"></span>Such files can be
            edited/viewed with e.g <a
              href="http://www.hdfgroup.org/hdf-java-html/hdfview">hdfview</a>.
            IDL and Matlab also have dedicated HDF 4 browsers (see <a
              href="matlab:doc%20hdftool">hdftool</a>). Also includes
            HDF-EOS format.</td>
          <td style="vertical-align: top;">Yes (image)<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="font-weight:
              bold;"><span style="color: rgb(204, 51, 204);">'hdf5'<br>
              </span></span><span style="color: rgb(204, 51, 204);">HDF
              5</span><span style="font-weight: bold;"><span
                style="color: rgb(204, 51, 204);"><br>
              </span></span></td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;">The <a
              href="http://www.hdfgroup.org/">HDF5</a> format is a
            compact, compressed binary storage format. However, in its
            use here, it partly reconstructs the initial object, with
            its main values and alias/axes names. Such files can be
            edited/viewed with e.g <a
              href="http://www.hdfgroup.org/hdf-java-html/hdfview">hdfview</a>,
            <a href="http://www.opendx.org/about.html">OpenDX, </a><a
              href="http://autoplot.org/">Autoplot</a>. Such files can
            of course also be <a href="Load.html">imported into iData</a>
            objects. Igor, IDL and Matlab also have dedicated HDF
            browsers (see <a href="matlab:doc%20hdftool">hdftool</a>).
            This format includes the <a href="http://nexusformat.org/">NeXus</a>
            format.<br>
            The <a href="https://root.cern.ch/drupal/">ROOT</a> data
            format (CERN) can be converted into HDF5 with <a
              href="http://www.rootpy.org">rootpy</a> (root2hdf5). You
            can also read and write such files using <a
              href="http://lamp.mccode.org/">LAMP</a>.<br>
          </td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="font-weight:
              bold; color: rgb(204, 51, 204);">'ibw'</span><span
              style="color: rgb(204, 51, 204);"> Igor pro Wave</span><br>
          </td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;"><a
              href="http://www.wavemetrics.com/">Igor pro</a> wave data
            file<br>
          </td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b>'lvm' 'tdms'</b><br>
              LabView</font><br>
          </td>
          <td valign="top">text/binary<br>
          </td>
          <td valign="top">LabView <a
              href="http://www.ni.com/white-paper/4139/en/">LVM</a>
            measurement file and <a
              href="http://www.ni.com/white-paper/3727/en/">TDMS</a>
            hierarchical technical data files</td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'mat'<br>
            </span><span style="color: rgb(204, 51, 204);">Matlab<br>
              Mat-file</span><span style="color: rgb(204, 51, 204);
              font-weight: bold;"><br>
            </span><span style="color: rgb(204, 51, 204); font-weight:
              bold;"><br>
            </span><br>
          </td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;">The Matlab workspace
            serialized binary file is compact and fast to read/write. It
            carries the whole object information. Such files require
            Matlab/iFit (or <a href="http://www.octave.org/">Octave</a>)
            to be installed prior to importation. To save a file use: <span
              style="color: rgb(51, 102, 255);">save</span>(a,<span
              style="color: rgb(204, 51, 204);">'mat_file'</span>,<span
              style="color: rgb(204, 51, 204);">'mat'</span>). To load
            it use <span style="color: rgb(51, 102, 255);">load</span>(iData,<span
              style="color: rgb(204, 51, 204);">'mat_file'</span>).</td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'nc'</span><span
              style="color: rgb(204, 51, 204);"> NetCDF</span><br>
          </td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;">The <a
              href="http://www.unidata.ucar.edu/software/netcdf/">NetCDF</a>
            format is a compact binary format. Such files can be
            edited/viewed with e.g <a
              href="http://meteora.ucsd.edu/%7Epierce/ncview_home_page.html">ncview</a>
            or <a href="http://www.hdfgroup.org/hdf-java-html/hdfview">hdfview</a>,
            <a href="http://www.epic.noaa.gov/java/ncBrowse/">ncBrowse</a>,
            <a href="http://www.opendx.org/about.html">OpenDX</a>, <a
              href="http://www.giss.nasa.gov/tools/panoply/">Panoply</a>,
            <a href="http://autoplot.org/">Autoplot</a>.<br>
          </td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b>'nrrd','nhdr' </b>Nearly
              Raw Raster Data</font><br>
          </td>
          <td valign="top">text/binary<br>
          </td>
          <td valign="top">A mixed text/binary format that can store nD
            data. Supported by e.g. <a
              href="http://users.loni.ucla.edu/%7Epipeline/viewer/">BrainViewer</a>,&nbsp;
            <a href="https://imagej.net/SCIFIO">ImageJ</a>, <a
              href="https://discourse.slicer.org/">Slicer</a>, ...<br>
          </td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc">'<b>npy</b>' NUMPY</font><br>
          </td>
          <td valign="top">binary<br>
          </td>
          <td valign="top">Numpy binary array <a
              href="https://docs.scipy.org/doc/numpy/neps/npy-format.html">NPY









              format</a> (single array)<br>
          </td>
          <td valign="top">yes<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="font-weight:
              bold;"><span style="color: rgb(204, 51, 204);">
                <meta http-equiv="content-type" content="text/html;
                  charset=windows-1252">
                'ppm' 'pgm' 'pbm'</span></span></td>
          <td style="vertical-align: top;">text<br>
          </td>
          <td style="vertical-align: top;"><a
              href="http://en.wikipedia.org/wiki/Netpbm_format">Standard
              image formats</a>. View with e.g. <a
              href="http://www.gimp.org/">GIMP</a>, <a
              href="http://www.trilon.com/xv/xv.html">xv</a>, <a
              href="file:///home/farhi/dev/iFit/Docs/rsbweb.nih.gov/ij/">ImageJ</a>.</td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b>'sav'</b> IDL</font><br>
          </td>
          <td valign="top">binary<br>
          </td>
          <td valign="top"><a
              href="https://en.wikipedia.org/wiki/IDL_%28programming_language%29">IDL</a>
            saved data (see format <a
              href="http://www.physics.wisc.edu/%7Ecraigm/idl/savefmt/">here</a>).






















            You can also read and write such files using <a
              href="http://lamp.mccode.org/">LAMP</a>.</td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="font-weight:
              bold;"></span><span style="color: rgb(204, 51, 204);
              font-weight: bold;">text<br>
            </span><span style="color: rgb(204, 51, 204);"></span><span
              style="color: rgb(204, 51, 204); font-weight: bold;">'xvg','dat','txt...<br>
            </span></td>
          <td style="vertical-align: top;">text<br>
          </td>
          <td style="vertical-align: top;">Any text file, using a free
            format, can be read. Any text editor (gedit, notepad, nedit,
            ...) can display such files. The XVG format is the native <a
              href="http://plasma-gate.weizmann.ac.il/Grace/">XmGrace</a>
            one.<br>
          </td>
          <td style="vertical-align: top;">Yes (DAT, M-file)<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'wav'</span><br
              style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);">Microsoft WAVE sound</span><br>
          </td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;">Sound format, standard<br>
          </td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'xls'</span><br
              style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);">Excel spreadsheet</span></td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;">Microsoft Excel spreadsheet.
            Can be viewed with any spreadsheet software (<a
              href="http://www.openoffice.org/">OpenOffice</a>, Excel, <a
              href="http://projects.gnome.org/gnumeric/">Gnumeric</a>)</td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'xml'</span><br
              style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);">XML description file</span><br>
          </td>
          <td style="vertical-align: top;">text<br>
          </td>
          <td style="vertical-align: top;">The <a
              href="http://www.w3.org/XML/">XML</a> format
            (experimental)<br>
          </td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'yaml','json'</span><br
              style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);">meta language
              configuration files</span><br>
          </td>
          <td style="vertical-align: top;">text<br>
          </td>
          <td style="vertical-align: top;">Data serialization format
            such as "<a href="http://en.wikipedia.org/wiki/YAML">YAML</a>
            Ain't <a
              href="http://en.wikipedia.org/wiki/Markup_language"
              title="Markup language">Markup Language</a>" and <a
              href="http://en.wikipedia.org/wiki/JSON">JSON</a>
            JavaScript Object Notation</td>
          <td style="vertical-align: top;">yes<br>
          </td>
        </tr>
      </tbody>
    </table>
    <span style="font-weight: bold;"></span>
    <h4><a class="mozTocH4" name="mozTocId361032"></a>More specific data
      formats (neutrons and X-ray, ...)</h4>
    <span style="font-weight: bold;"> </span>
    <table style="text-align: left; width: 100%;" border="1"
      cellpadding="2" cellspacing="2">
      <tbody>
        <tr>
          <td style="vertical-align: top; background-color: rgb(255,
            204, 204); font-weight: bold; font-style: italic;">format
            (load)<br>
          </td>
          <td style="vertical-align: top; background-color: rgb(255,
            204, 204); font-weight: bold; font-style: italic;">Text/Binary<br>
          </td>
          <td style="vertical-align: top; background-color: rgb(255,
            204, 204); font-weight: bold; font-style: italic;">Description<br>
          </td>
          <td style="vertical-align: top;"><span style="font-weight:
              bold;">iData/saveas</span><br style="font-weight: bold;">
            <span style="font-weight: bold;"> Write</span><br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b>'</b><b>0001','0002'...</b><b><br>
              </b><b>Bruker FT-IR OPUS</b></font><br>
          </td>
          <td valign="top">binary<br>
          </td>
          <td valign="top">FT-IR Bruker <a
href="http://www.bruker.com/fr/products/infrared-near-infrared-and-raman-spectroscopy/opus-software/overview.html">OPUS</a>
            format<br>
          </td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top; color: rgb(204, 51, 204);"><span
              style="font-weight: bold;">acqus, fid or ser</span><br>
            Bruker NMR<br>
          </td>
          <td style="vertical-align: top;">text<br>
          </td>
          <td style="vertical-align: top;">NMR data set from
            Bruker/WinNMR<br>
          </td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="font-weight:
              bold; color: rgb(204, 51, 204);">'cbf'<br>
            </span><span style="color: rgb(204, 51, 204);">ESRF/SLS</span><span
              style="color: rgb(204, 51, 204);"> binary imgCIF</span><span
              style="font-weight: bold; color: rgb(204, 51, 204);"><br>
            </span></td>
          <td style="vertical-align: top;">binary with 4096-multiple
            length text header<br>
          </td>
          <td style="vertical-align: top;">The Crystallographic Binary
            File format, used on some X-ray and neutron diffractometers.
            See the <a
              href="http://www.esrf.fr/computing/Forum/imgCIF/cbf_definition.html">format
































              definition</a>. This format gathers <span
              style="font-style: italic;">CIF</span> and <span
              style="font-style: italic;">imgCIF</span> standards. These
            files are e.g. generated by <a
              href="https://www.dectris.com/">Pilatus</a> CCD Cameras.<br>
          </td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">CIF, CFL/PCR, INS/RES</span><br
              style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);">Crystallography
              files (FullProf, ShelX)</span><br>
          </td>
          <td style="vertical-align: top;">text<br>
          </td>
          <td style="vertical-align: top;">The <a
              href="http://en.wikipedia.org/wiki/Crystallographic_Information_File">CIF</a>
            format is the <a href="http://www.iucr.org/">IUCr</a>
            standard format for structure descriptions. The PCR and CFL
            file formats are used by <a
              href="http://www.ill.eu/sites/fullprof/">FullProf</a> and
            <a
href="http://www.ill.eu/sites/fullprof/php/programs24b7.html?pagina=Crysfml">CrysFML</a>.
            The RES, SHX and INS formats are used by <a
              href="http://shelx.uni-ac.gwdg.de/SHELX/">ShelX</a>. Such
            files can be viewed by <a
              href="http://www.lwfinger.net/drawxtl/">DrawXtl</a>, <a
              href="http://jmol.sourceforge.net/">JMol</a>, <a
              href="http://www.pymol.org/">PyMol</a>, <a
              href="http://rasmol.org/">RasMol</a>, <a
              href="http://avogadro.openmolecules.net/wiki/Main_Page">Avogadro,</a>
            <a href="http://gdis.sourceforge.net/">GDis, </a><a
              href="http://www.cgl.ucsf.edu/chimera/">Chimera </a><a
              href="http://www.yasara.org/">Yasara</a><br>
            <br>
            <font size="+1"><span style="color: rgb(0, 0, 0); font-size:
                medium; font-style: normal; font-variant-ligatures:
                normal; font-variant-caps: normal; font-weight: 400;
                letter-spacing: normal; text-align: left; text-indent:
                0px; text-transform: none; white-space: normal;
                word-spacing: 0px; -webkit-text-stroke-width: 0px;
                text-decoration-style: initial; text-decoration-color:
                initial; display: inline ! important; float: none;">It
                is also possible to get a CIF file automatically from
                the<span>&nbsp;</span></span><a
                href="http://www.crystallography.net" style="font-size:
                medium; font-style: normal; font-variant-ligatures:
                normal; font-variant-caps: normal; font-weight: 400;
                letter-spacing: normal; text-align: left; text-indent:
                0px; text-transform: none; white-space: normal;
                word-spacing: 0px; -webkit-text-stroke-width: 0px;">Crystallography








                Open Database</a><span style="color: rgb(0, 0, 0);
                font-size: medium; font-style: normal;
                font-variant-ligatures: normal; font-variant-caps:
                normal; font-weight: 400; letter-spacing: normal;
                text-align: left; text-indent: 0px; text-transform:
                none; white-space: normal; word-spacing: 0px;
                -webkit-text-stroke-width: 0px; text-decoration-style:
                initial; text-decoration-color: initial; display: inline
                ! important; float: none;"><span>&nbsp;</span>with:<span>&nbsp;</span></span><i
                style="color: rgb(0, 0, 0); font-size: medium;
                font-variant-ligatures: normal; font-variant-caps:
                normal; font-weight: 400; letter-spacing: normal;
                text-align: left; text-indent: 0px; text-transform:
                none; white-space: normal; word-spacing: 0px;
                -webkit-text-stroke-width: 0px; text-decoration-style:
                initial; text-decoration-color: initial;">read_cif(</i><i
                style="color: rgb(0, 0, 0); font-size: medium;
                font-variant-ligatures: normal; font-variant-caps:
                normal; font-weight: 400; letter-spacing: normal;
                text-align: left; text-indent: 0px; text-transform:
                none; white-space: normal; word-spacing: 0px;
                -webkit-text-stroke-width: 0px; text-decoration-style:
                initial; text-decoration-color: initial;"><font
                  color="#cc33cc">'cod: ID'</font></i><i style="color:
                rgb(0, 0, 0); font-size: medium; font-variant-ligatures:
                normal; font-variant-caps: normal; font-weight: 400;
                letter-spacing: normal; text-align: left; text-indent:
                0px; text-transform: none; white-space: normal;
                word-spacing: 0px; -webkit-text-stroke-width: 0px;
                text-decoration-style: initial; text-decoration-color:
                initial;">)</i><span style="color: rgb(0, 0, 0);
                font-size: medium; font-style: normal;
                font-variant-ligatures: normal; font-variant-caps:
                normal; font-weight: 400; letter-spacing: normal;
                text-align: left; text-indent: 0px; text-transform:
                none; white-space: normal; word-spacing: 0px;
                -webkit-text-stroke-width: 0px; text-decoration-style:
                initial; text-decoration-color: initial; display: inline
                ! important; float: none;"><span>&nbsp;</span>and<span>&nbsp;</span></span><i
                style="color: rgb(0, 0, 0); font-size: medium;
                font-variant-ligatures: normal; font-variant-caps:
                normal; font-weight: 400; letter-spacing: normal;
                text-align: left; text-indent: 0px; text-transform:
                none; white-space: normal; word-spacing: 0px;
                -webkit-text-stroke-width: 0px; text-decoration-style:
                initial; text-decoration-color: initial;">read_cif(</i><i
                style="color: rgb(0, 0, 0); font-size: medium;
                font-variant-ligatures: normal; font-variant-caps:
                normal; font-weight: 400; letter-spacing: normal;
                text-align: left; text-indent: 0px; text-transform:
                none; white-space: normal; word-spacing: 0px;
                -webkit-text-stroke-width: 0px; text-decoration-style:
                initial; text-decoration-color: initial;"><font
                  color="#cc33cc">'cod: chem_formula'</font></i><i
                style="color: rgb(0, 0, 0); font-size: medium;
                font-variant-ligatures: normal; font-variant-caps:
                normal; font-weight: 400; letter-spacing: normal;
                text-align: left; text-indent: 0px; text-transform:
                none; white-space: normal; word-spacing: 0px;
                -webkit-text-stroke-width: 0px; text-decoration-style:
                initial; text-decoration-color: initial;">)</i><span
                style="color: rgb(0, 0, 0); font-size: medium;
                font-style: normal; font-variant-ligatures: normal;
                font-variant-caps: normal; font-weight: 400;
                letter-spacing: normal; text-align: left; text-indent:
                0px; text-transform: none; white-space: normal;
                word-spacing: 0px; -webkit-text-stroke-width: 0px;
                text-decoration-style: initial; text-decoration-color:
                initial; display: inline ! important; float: none;"><span>&nbsp;</span>which








                both require a valid network connection (and proxy if
                any). See more details<span>&nbsp;</span></span><a
href="file:///home/farhi/dev/iFit/Docs/Models_Phonons_Tutorial.html#mozTocId250682"
                style="font-size: medium; font-style: normal;
                font-variant-ligatures: normal; font-variant-caps:
                normal; font-weight: 400; letter-spacing: normal;
                text-align: left; text-indent: 0px; text-transform:
                none; white-space: normal; word-spacing: 0px;
                -webkit-text-stroke-width: 0px;">here</a><span
                style="color: rgb(0, 0, 0); font-size: medium;
                font-style: normal; font-variant-ligatures: normal;
                font-variant-caps: normal; font-weight: 400;
                letter-spacing: normal; text-align: left; text-indent:
                0px; text-transform: none; white-space: normal;
                word-spacing: 0px; -webkit-text-stroke-width: 0px;
                text-decoration-style: initial; text-decoration-color:
                initial; display: inline ! important; float: none;">.</span></font></td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="font-weight:
              bold; color: rgb(204, 51, 204);">ChalkRiver CNBC/NRU</span><br>
          </td>
          <td style="vertical-align: top;">text<br>
          </td>
          <td style="vertical-align: top;">Files generated by the <a
              href="http://www.nrc-cnrc.gc.ca/cnbc/">CNBC</a> NRU
            instruments at Chalk River. Multi-wire and polarized data
            files are supported.<br>
          </td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b>DAT</b></font><br>
          </td>
          <td valign="top">text<br>
          </td>
          <td valign="top"><a
              href="http://www.qdusa.com/products/mpms3.html">Quantum
              Design</a> VMS ppms/mpms<br>
          </td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b>DX</b> Electronic
              Chemistry Exchange format</font><br>
          </td>
          <td valign="top">text<br>
          </td>
          <td valign="top">Electronic Chemistry Exchange format from
            IUPAC (<a href="http://www.jcamp-dx.org/">JCAMP-DX</a>)<br>
          </td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'edf'</span><br
              style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);">EDF ESRF Data format</span><span
              style="font-weight: bold;"><span style="color: rgb(204,
                51, 204);"> </span></span></td>
          <td style="vertical-align: top;">binary with 512-multiple
            length text header </td>
          <td style="vertical-align: top;">The EDF format is mainly used
            at the <a href="http://www.esrf.fr/">ESRF</a> and can be
            viewed with e.g. <a href="http://pymca.sourceforge.net/">PyMCA</a>,
            <a
              href="http://www.sci.muni.cz/%7Emikulik/Soft4Synchro.html">Zimg</a>,
            <a href="http://www.gnuplot.info/">GnuPlot</a>, <a
              href="http://edfexplorer.sourceforge.net/">EDFExplorer</a>,
            <a href="http://www.esrf.eu/computing/scientific/FIT2D/">Fit2D</a>,
            <a href="http://sourceforge.net/apps/trac/fable/wiki/fabio">FabIO</a>.<br>
          </td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b><font
                  color="#cc33cc"><b>ENDF </b></font>TSL DAT</b><br>
              Evaluated Nuclear Data File</font><br>
          </td>
          <td valign="top">text<br>
          </td>
          <td valign="top"><a
              href="https://www.oecd-nea.org/dbdata/data/manual-endf/endf102.pdf">ENDF</a>
            <a href="https://en.wikipedia.org/wiki/Nuclear_data">Evaluated














              Nuclear Data File</a> with specific support for the
            thermal neutron scattering law (TSL) section (MF7, MT=2 and
            4). Can make use of <a href="http://pyne.io/">PyNE</a> when
            installed.<br>
          </td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top; color: rgb(204, 51, 204);"><span
              style="font-weight: bold;">fid, procpar</span><br>
            Varian NMR<br>
          </td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;">NMR data set from Varian</td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b>GCODE</b> Numerical
              control coordinates</font><br>
          </td>
          <td valign="top">text<br>
          </td>
          <td valign="top">Numerical control programming language</td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top; color: rgb(204, 51, 204);"><span
              style="font-weight: bold;">'hdr','jdf'</span><br>
            JEOL NMR<br>
          </td>
          <td style="vertical-align: top;">text/binary<br>
          </td>
          <td style="vertical-align: top;">NMR data set from JEOL<br>
          </td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'hdr'</span>+'img'<br
              style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);">MRI 3D volume</span><br>
          </td>
          <td style="vertical-align: top;">binary (2 files)<br>
          </td>
          <td style="vertical-align: top;">A MRI volume data format. The
            'hdr' file requires an ssociated 'img' file. <a
              href="http://en.wikipedia.org/wiki/Analyze_%28imaging_software%29">Format</a>
            from the Analyze <a href="http://www.analyzedirect.com/">Biomedical
































              Imaging Resource of the Mayo Clinic</a>.Analyze files can
            be obtained from <a
              href="http://en.wikipedia.org/wiki/DICOM">DICOM</a> files
            using e.g. <a
              href="http://cbi.nyu.edu/software/dinifti.php">DicomNifti</a>,
            <a href="http://od1n.sourceforge.net/">MiTools</a>, <a
              href="http://lcni.uoregon.edu/%7Ejolinda/MRIConvert/">MRIconvert</a>,
            or the Matlab tool <a
href="http://www.mathworks.com/matlabcentral/fileexchange/42997-dicom-to-nifti-converter">dicm2nii</a>.
            You can view with <a
              href="http://svn.softwarepublico.gov.br/trac/invesalius">Invesalius</a>,
            MiView (<a href="http://od1n.sourceforge.net/">MiTools</a>),
            <a href="http://cnl.web.arizona.edu/mricro.htm">MRICron</a>.<br>
          </td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b>'hspy'</b><br>
              HypersPy</font><br>
          </td>
          <td valign="top">binary<br>
          </td>
          <td valign="top">This is an <a
              href="http://www.hdfgroup.org/">HDF5</a> flavour used by <a
              href="https://hyperspy.org/"> HypersPy</a> for
            multi-spectral analysis (e.g. an image for which each pixel
            carries a 1D/2D signal).<br>
          </td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">ILL data<br>
            </span><span style="color: rgb(204, 51, 204);"></span><span
              style="color: rgb(204, 51, 204); font-weight: bold;"><br>
            </span></td>
          <td style="vertical-align: top;">text<br>
          </td>
          <td style="vertical-align: top;">Files generated by <a
              href="http://www.ill.fr">ILL</a> instruments, with
            specific support for ILL TAS. May require post-processing to
            assign Signal and axes right, as well as metadata. This data
            can also be imported with <a
href="http://www.ill.eu/instruments-support/computing-for-science/cs-software/all-software/lamp/">Lamp</a>.
          </td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td valign="top"><b><font color="#cc33cc">ILL Cyclops Laue
                camera</font></b><br>
          </td>
          <td valign="top">text/binary<br>
          </td>
          <td valign="top">Specific data format for the <a
href="http://www.ill.eu/instruments-support/instruments-groups/instruments/cyclops/description/instrument-layout/">Cyclops</a>
            Neutron Laue diffractometer, which measures the reciprocal
            space image of a sample structure.<br>
          </td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'img' </span><br
              style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);">ADSC image</span><br>
          </td>
          <td style="vertical-align: top;">binary with 512 char header<br>
          </td>
          <td style="vertical-align: top;"><a
              href="http://www.adsc-xray.com/products.html">ADSC</a> CCD
            Camera<br>
          </td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="font-weight:
              bold;"><span style="color: rgb(204, 51, 204);">'inx'<br>
              </span></span><font color="#cc33cc">INX ILL</font><span
              style="font-weight: bold;"><span style="color: rgb(204,
                51, 204);"><br>
              </span></span></td>
          <td style="vertical-align: top;">text<br>
          </td>
          <td style="vertical-align: top;">The <a
href="http://www.ill.eu/instruments-support/computing-for-science/cs-software/all-software/tofhr/inx/">INX</a>
            format is a S(phi,w) simple format for reduced neutron
            time-of-flight data (see <a
href="http://www.ill.eu/instruments-support/instruments-groups/groups/tof/software/inx/">example</a>).
































            This data can also be imported/generated with <a
href="http://www.ill.eu/instruments-support/computing-for-science/cs-software/all-software/lamp/">Lamp</a>.</td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'mar','mccd'</span><br
              style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);">MarResearch</span><br>
          </td>
          <td style="vertical-align: top;">binary (TIFF)<br>
          </td>
          <td style="vertical-align: top;"><a
              href="http://www.marresearch.com/">MarResearch</a> CCD
            Camera (<a
              href="http://www.marresearch.com/man/mar345_formats.htm">Mar345</a>)
            format, can also be imported as a TIFF format<br>
          </td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b>MCNP ACE</b><br>
              A compact ENDF</font><br>
          </td>
          <td valign="top">text/binary<br>
          </td>
          <td valign="top">ACE <a href="https://mcnp.lanl.gov/">MCNP</a>
            files ("A Compact ENDF"). Requires <a
              href="http://pyne.io/">PyNE</a> to be installed.<br>
          </td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">MRC/CCP4/IMOD, EZD</span><br
              style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);">electron density map</span><br>
          </td>
          <td style="vertical-align: top;">text(EZD) and binary<br>
          </td>
          <td style="vertical-align: top;">Electron density maps in <a
              href="http://en.wikipedia.org/wiki/MRC_%28file_format%29">MRC</a>/<a
              href="http://en.wikipedia.org/wiki/CCP4_%28file_format%29">CCP4</a>
            and <a
href="http://www.msg.ucsf.edu/local/programs/ono/manuals/ofaq/Q.803.html">EZD</a>
            file formats. Can be visualized with <a
              href="http://www.pymol.org/">PyMol</a>, <a
              href="http://www.ks.uiuc.edu/Research/vmd/">VMD</a>, <a
              href="http://www.cgl.ucsf.edu/chimera/">Chimera</a>, <a
              href="http://www.yasara.org">Yasara</a>, <a
              href="http://mem.ibs.fr/VEDA/">VEDA</a>.<br>
          </td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b>MS, D, RAW</b><br>
              Agilent and Thermo Finnigan MS</font><br>
          </td>
          <td valign="top">binary<br>
          </td>
          <td valign="top">Agilent Mass Spectrometry/Chromatography
            LC/MS GC/MS GC/FID<br>
            Thermo Finnigan Mass Spectrometry/Chromatography<br>
          </td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;"></span><span style="color:
              rgb(204, 51, 204); font-weight: bold;">'nii'</span><br
              style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204); font-weight: bold;">NifTI</span>
            <span style="color: rgb(204, 51, 204); font-weight: bold;"></span><span
              style="color: rgb(204, 51, 204);">MRI volume</span><br>
          </td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;">A <a
              href="http://nifti.nimh.nih.gov/">NifTI</a> medical
            imaging volume data format (MRI). Such files can be obtained
            from <a href="http://en.wikipedia.org/wiki/DICOM">DICOM</a>
            files using e.g. <a
              href="http://cbi.nyu.edu/software/dinifti.php">DicomNifti</a>,
            <a href="http://od1n.sourceforge.net/">MiTools</a>, <a
              href="http://lcni.uoregon.edu/%7Ejolinda/MRIConvert/">MRIconvert</a>,
            or the Matlab tool <a
href="http://www.mathworks.com/matlabcentral/fileexchange/42997-dicom-to-nifti-converter">dicm2nii</a>.
            You can view with MiView (<a
              href="http://od1n.sourceforge.net/">MiTools</a>), <a
              href="http://cnl.web.arizona.edu/mricro.htm">MRICron</a>.
          </td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'nx','nxs','n4',<br>
              'n5','nxspe','cxi'</span><br>
            <font color="#cc33cc">NeXus</font><br>
          </td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;">The <a
              href="http://nexusformat.org/">NeXus</a> files are HDF4/5
            files. See above format description for more information.
            This format includes all types of derivatives (such as NX
            SPE from ISIS, and <a href="https://www.cxidb.org/">CXI</a>).




            Such files can be edited/viewed with e.g <a
              href="http://www.hdfgroup.org/hdf-java-html/hdfview">hdfview</a>
            and <a href="http://www.silx.org/">silx</a> view.<br>
          </td>
          <td style="vertical-align: top;">Yes (as HDF5)<br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b>'nxs'</b> Mantid
              workspace</font><br>
          </td>
          <td valign="top">binary<br>
          </td>
          <td valign="top">Specific support for reading <a
              href="http://www.mantidproject.org">Mantid</a> and <a
href="http://www.ill.eu/instruments-support/computing-for-science/cs-software/all-software/lamp/">Lamp</a>
            workspaces.<br>
          </td>
          <td valign="top">Yes<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">PDB file</span><br>
          </td>
          <td style="vertical-align: top;">text<br>
          </td>
          <td style="vertical-align: top;"><a
              href="http://www.rcsb.org/pdb/">Protein Data Bank</a> file
            describing e.g. proteins. View with e.g. <a
              href="http://jmol.sourceforge.net">Jmol</a>. The file
            structure is read, the gyration radius <span
              style="font-style: italic;">Rg</span>, Protein density,
            volume, excess charge, scattering structure factor <span
              style="font-style: italic;">S(q)</span> and pair
            correlation function. These files can be viewed by <a
              href="http://jmol.sourceforge.net/">JMol</a>, <a
              href="http://www.pymol.org/">PyMol</a>, <a
              href="http://viewmol.sourceforge.net/">ViewMol</a>, <a
              href="http://rasmol.org/">RasMol</a>, <a
              href="http://avogadro.openmolecules.net/wiki/Main_Page">Avogadro,</a>
            <a
              href="http://msg.ucsf.edu/local/programs/garlic/index.html">Garlic</a>,
            <a href="http://gdis.sourceforge.net/">GDis</a>, <a
              href="http://www.ks.uiuc.edu/Research/vmd/">VMD</a>, <a
              href="http://www.cgl.ucsf.edu/chimera/">Chimera</a> <a
              href="http://www.yasara.org/">Yasara</a> ...<br>
          </td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td valign="top"><b><font color="#cc33cc">POSCAR</font></b><br>
          </td>
          <td valign="top">text<br>
          </td>
          <td valign="top">VASP <a
              href="http://cms.mpi.univie.ac.at/vasp/guide/node59.html">POSCAR</a>
            file for molecular modelling. See with <a
              href="http://www.ks.uiuc.edu/Research/vmd/">VMD</a>. </td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td valign="top"><b><font color="#cc33cc">'R*' and 'C*'<br>
                LLB TAS</font></b><br>
          </td>
          <td valign="top">binary<br>
          </td>
          <td valign="top">LLB TAS (1T, 2T, 4F1, 4F2, G43). <i><font
                color="#ff0000">Experimental</font>. May not be properly
              imported</i>. Users are advised to use B. Hennion
            conversion tools (convasc, convdat from 'wf').<br>
          </td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td valign="top"><b><font color="#cc33cc">SDF </font></b><font
              color="#cc33cc"><br>
              HP/Agilent/Keysight</font></td>
          <td valign="top">binary<br>
          </td>
          <td valign="top">HP/Agilent/Keysight Standard Data Format
            (SDF)<br>
          </td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'sif'</span><br
              style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);">Andor Technology</span><br>
          </td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;"><a
              href="http://www.andor.com/scientific-cameras">Andor
              Technology</a> CCD Camera file<br>
          </td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'sim'<br>
            </span><span style="color: rgb(204, 51, 204);">McStas/PGPLOT</span><br>
          </td>
          <td style="vertical-align: top;">text<br>
          </td>
          <td style="vertical-align: top;">The legacy format generated
            by <a href="http://www.mcstas.org">McStas</a>. Support for
            1D, 2D and event lists.<br>
          </td>
          <td style="vertical-align: top;">Yes, similar to the DAT
            export format<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'spc'<br>
            </span><span style="color: rgb(204, 51, 204);">SPEC</span><br>
          </td>
          <td style="vertical-align: top;">text<br>
          </td>
          <td style="vertical-align: top;">The <a
              href="http://www.certif.com/">SPEC</a> <a
              href="http://www.esrf.fr">ESRF</a> legacy format. May be
            slow to import due to the file format complexity for large
            files.</td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'spe'<br>
            </span><span style="color: rgb(204, 51, 204);">ISIS SPE</span><span
              style="color: rgb(204, 51, 204); font-weight: bold;"><br>
            </span></td>
          <td style="vertical-align: top;">text<br>
          </td>
          <td style="vertical-align: top;">The SPE data format is a
            S(phi,w) obtained after processing ISIS RAW files with <a
              href="http://horace.isis.rl.ac.uk/">Horace</a> and <a
              href="http://www.libisis.org/">LibISIS</a> (Homer/2d).<br>
          </td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="color: rgb(204,
              51, 204); font-weight: bold;">'spe'</span><br
              style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);">Roper Scientific</span><br>
          </td>
          <td style="vertical-align: top;">binary<br>
          </td>
          <td style="vertical-align: top;"><a
              href="http://www.princetoninstruments.com/products/software/#1">Princeton/Roper
































              Scientific WinView</a> / PI Acton image file<br>
          </td>
          <td style="vertical-align: top;"><br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b>SPINWAVE</b> LLB</font><br>
          </td>
          <td valign="top">text<br>
          </td>
          <td valign="top">A <a
              href="http://www-llb.cea.fr/logicielsllb/SpinWave/SW.html">SPINWAVE</a>
            (LLB) input for to model spin-waves [text]<br>
          </td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top; font-weight: bold; color:
            rgb(204, 51, 204);">'sqw','laz','lau'<br>
            <span style="font-weight: normal;">McStas sample files</span><br>
          </td>
          <td style="vertical-align: top;">text<br>
          </td>
          <td style="vertical-align: top;">Sample files for <span
              style="font-style: italic;">Isotropic_Sqw, PowderN</span>
            and <span style="font-style: italic;">Single_crystal</span>
            <a href="http://www.mcstas.org/">McStas</a> components,
            resp. obtained from <a
              href="https://forge.ill.eu/projects/nmoldyn">nMoldyn, </a><a
              href="http://www.ill.eu/sites/fullprof/">FullProf,</a> <a
              href="http://icsd.ill.fr">ICSD</a> and <a
              href="http://www.oxcryo.com/software/crystallographica">Crystallographica</a>.
            <i>The McStas Sqw </i><i>format is </i><i><b>not</b></i><i>
              similar to the Sqw Horace objects.</i> </td>
          <td style="vertical-align: top;">Yes for <b>'sqw'<br>
            </b>Can create Lau nd Laz with <b><i>ci</i></b><b><i>f2hkl</i></b>.<b><br>
            </b> </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b>'sqw'</b><br>
              ISIS SQW</font><br>
          </td>
          <td valign="top">binary<br>
          </td>
          <td valign="top">The SQW data format is obtained after
            processing ISIS RAW files with <a
              href="http://horace.isis.rl.ac.uk/">Horace</a> and <a
              href="http://www.libisis.org/">LibISIS</a>. <i>This
              format is binary, and is not similar to the Mcstas Sqw
              format.</i><br>
          </td>
          <td valign="top"><br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b>SQW4D</b> McStas</font><br>
          </td>
          <td valign="top">text<br>
          </td>
          <td valign="top">Sqw 4D data set for <a
href="http://www.mcstas.org/download/components/contrib/Single_crystal_inelastic.html">McStas






              Single_crystal_inelastic</a> component. <i>This format is
              <b>not</b> similar to the Sqw Horace objects.<br>
            </i></td>
          <td valign="top">Yes<br>
          </td>
        </tr>
        <tr>
          <td style="vertical-align: top;"><span style="font-weight:
              bold; color: rgb(204, 51, 204);">STL/SLP/PLY/OFF/OBJ</span><br
              style="color: rgb(204, 51, 204);">
            <span style="color: rgb(204, 51, 204);"> Volume/geometry</span><br>
            <br>
          </td>
          <td style="vertical-align: top;">text or binary<br>
          </td>
          <td style="vertical-align: top;">The <a
              href="en.wikipedia.org/wiki/STL_%28file_format%29">STL</a>
            SLP <a href="http://www.geomview.org/docs/html/OFF.html">OFF</a>
            <a href="http://en.wikipedia.org/wiki/Wavefront_.obj_file">OBJ</a>
            and <a
              href="http://en.wikipedia.org/wiki/PLY_%28file_format%29">PLY</a>
            format are common in&nbsp; stereo-lithography CAD software.
            They describe raw unstructured triangulated surfaces/volumes
            by the unit <span class="mw-redirect">normal</span> and
            vertices (ordered by the right-hand rule) of the triangles
            using a three-dimensional Cartesian coordinate system. These
            files can be viewed with e.g. <a
              href="http://meshlab.sourceforge.net/">MeshLab</a>, <a
              href="http://www.varlog.com/admesh-htm">AdMesh</a>, <a
              href="http://free-cad.sourceforge.net/">FreeCAD</a>, <a
              href="http://www.geomview.org/">Geomview</a>, <a
              href="http://www.cgl.ucsf.edu/chimera/">Chimera</a>. </td>
          <td style="vertical-align: top;">Yes<br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b>VOL</b> RAW binary
              float32<br>
              Tomography PyHST2</font><br>
          </td>
          <td valign="top">binary<br>
          </td>
          <td valign="top">A raw binary array (float32). An associated
            .PAR file provides dimensions. Generated by e.g. <a
              href="http://ftp.esrf.fr/scisoft/PYHST2/">PyHST2</a>.<br>
          </td>
          <td valign="top"><br>
          </td>
        </tr>
      </tbody>
    </table>
    <br>
    <h4><a class="mozTocH4" name="mozTocId149630"></a>Unsupported data
      formats: how to import them anyway ?</h4>
    <b><i>Text files (ascii)</i></b><br>
    In principle, any <span style="font-weight: bold;">text</span>
    based data format will be imported, whatever be the internal
    organization of the data and comments. The text is read and parsed
    by the <a href="../Libraries/Loaders/doc/looktxt.html">looktxt</a>
    tool, and all numerical blocks are named automatically from the
    character strings/comments that precede these blocks. The result is
    a single structure which holds a <span style="font-style: italic;">Data</span>
    and a <span style="font-style: italic;">Header</span> field, plus
    additional identification information. The structure can be
    converted transparently to an <a href="iData.html">iData</a>
    object. However, in some cases, the Signal and Axes definitions will
    require to be set after creating the object.<br>
    <br>
    If you can not import a reluctant <span style="font-weight: bold;">text</span>
    file, try the most tolerant text reader configurations:<br>
    <pre style="margin-left: 40px;">&gt;&gt; <span style="color: rgb(51, 102, 255);">iData</span>(<span style="color: rgb(204, 51, 204);">'filename','text format with fast import method'</span>)<br>&gt;&gt; <span style="color: rgb(51, 102, 255);">iData</span>(<span style="color: rgb(204, 51, 204);">'filename','Data (text format)'</span>)<br></pre>
    will import the raw content, without post formatting of the object
    in memory. You will probably need to assign manually some of the
    Signal and Axes (see <a href="iData.html">iData</a> object help).
    It may be that the <span style="font-style: italic;">looktxt</span>
    MeX file is corrupted. Refer to the <a
      href="Changes.html#mozTocId556618">Changes/Bugs</a> and <a
      href="Install.html#mozTocId359173">Install</a> pages.<br>
    <br>
    You can tune the way a text file is read with the syntax (each
    option is an argument in its own):<br>
    <pre style="margin-left: 40px;">&gt;&gt; a=<span style="color: rgb(51, 102, 255);">iLoad</span>(<i>filename</i>, <font color="#cc33cc">'text'</font>, <font color="#cc33cc">'--catenate'</font>,<font color="#cc33cc">'--fast'</font>,<font color="#cc33cc">'--headers'</font>,<font color="#cc33cc">'--wrapped'</font>, <i>... other options</i>);<span style="color: rgb(204, 51, 204);"></span></pre>
    where <b>'text'</b> indicates that the file is not binary encoded,
    and any following options is forwarded to the text reader. The
    possible options are:<br>
    <br>
    <table border="1" cellpadding="2" cellspacing="2" width="100%">
      <tbody>
        <tr>
          <td align="center" valign="top"><i>Text import option</i><i><br>
            </i></td>
          <td align="center" valign="top"><i>Description</i><i><br>
            </i></td>
        </tr>
        <tr>
          <td valign="top"><b><font color="#cc33cc">'--catenate' </font></b></td>
          <td valign="top">Catenates similar numerical fields (which
            have similar dimensions and names. <b>Recommended.</b> </td>
        </tr>
        <tr>
          <td valign="top"><b><font color="#cc33cc">'--fast'<br>
              </font></b></td>
          <td valign="top">When numerical data blocks only use <a
              href="http://manpages.ubuntu.com/manpages/man3/isalpha.3.html">isspace</a>(3)










            separators (\n \r \f \t \v and space), the reading can be
            made faster with even lower memory requirements. <b>Recommended.</b></td>
        </tr>
        <tr>
          <td valign="top"><b><font color="#cc33cc">'--headers'<br>
              </font></b></td>
          <td valign="top">Extracts <i>headers</i> for each numerical
            field. <b>Recommended.</b></td>
        </tr>
        <tr>
          <td valign="top"><b><font color="#cc33cc">'--wrapped'<br>
              </font></b></td>
          <td valign="top">Catenates single wrapped output lines with
            previous matrices (e.g. caused by the 80 chars per line
            limit in old data formats written by fortran codes). <b>Recommended.</b><br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc">'--section=SEC'<br>
            </font></td>
          <td valign="top">Classifies fields into <i>sections</i>
            matching word SEC. This option can be repeated with
            different SEC words.<br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc">'--metadata=META'</font><br>
          </td>
          <td valign="top">Extracts lines containing word META as user <i>metadata.</i>
            This option can be repeated with different META items.</td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc">'--makerows=NAME'</font></td>
          <td valign="top">When a numerical data block label matching
            NAME is found, it is transformed into a row vector. This may
            be used for wrapped files (<i>--wrapped</i> option). This
            option can be repeatedwith as different NAME tokens.<br>
          </td>
        </tr>
        <tr>
          <td valign="top"><font color="#cc33cc"><b>'--help'</b></font><br>
          </td>
          <td valign="top">Lists all possible options.<br>
          </td>
        </tr>
      </tbody>
    </table>
    <br>
    The full list of options can be obtained with:<br>
    <pre style="margin-left: 40px;">&gt;&gt; <span style="color: rgb(51, 102, 255);">iLoad</span>(<font color="#cc33cc">' '</font>,<font color="#cc33cc">'text'</font>,<font color="#cc33cc">'--help'</font>)</pre>
    These options can be specified in the 'options' field of an iLoad
    configuration entry (see below). The same options can also be used
    when importing directly into an iData object (replace 'iLoad' by
    'iData' in the example above).<br>
    <br>
    <br>
    <i><b> </b></i><i><b>Binary files</b></i><br>
    Binary formats require more work. In principle, if <span
      style="font-style: italic;">iLoad</span> does not know the
    structure of the file, there is no way to import an unknown binary
    data format file. However, <span style="font-style: italic;">iLoad</span>
    allows a rapid prototyping of new import filters by mean of a simple
    routine that should take as input a file name, and return a
    structure or numerical block. Additionally, a post-process script
    can be attached to the new format, and executed when the file
    content is converted into an <span style="font-style: italic;">iData</span>
    object. The specifications of the new data format will then be
    inserted inside the <span style="font-style: italic;">iLoad_ini</span>
    configuration (locally or globally) together with e.g. file
    extension and other identification info. These steps are detailed in
    the <a href="#mozTocId519997">section below</a>.<br>
    <br>
    The <span style="font-weight: bold;">class2str </span>function can
    more generally write any Matlab variable as a character string. And
    the <span style="font-weight: bold;">str2struct</span> function can
    read a character string and search for [<span style="font-style:
      italic;">name</span>{=: }<span style="font-style: italic;">value</span>]
    pairs in single lines, to set a return structure.<br>
    <h3><a class="mozTocH3" name="mozTocId519997"></a>The import
      filters: customizing data formats (iLoad_ini)<br>
    </h3>
    <h4><a class="mozTocH4" name="mozTocId56356"></a>Reading and Writing
      the iLoad configuration</h4>
    The full list of supported file formats supported by iLoad and iData
    can be obtained from command<br>
    <pre style="margin-left: 40px;">&gt;&gt; <span style="color: rgb(51, 102, 255);">iLoad</span>(<span style="color: rgb(204, 51, 204);">'formats'</span>);	<span style="font-style: italic;">% display the list of supported formats</span><br>&gt;&gt; <span style="color: rgb(51, 102, 255);">iLoad</span>(<span style="color: rgb(204, 51, 204);"></span><span style="color: rgb(204, 51, 204);">'force'</span>);	<span style="font-style: italic;">% force re-read of the configuration file</span> and check importers<br></pre>
    The configuration file <a href="../Loaders/iLoad_ini.m">iLoad_ini</a><span
      style="font-weight: bold;"></span> is stored by default in the <br>
    <pre style="margin-left: 40px;">fullfile( <span style="color: rgb(51, 102, 255);">ifitpath,</span> <span style="color: rgb(204, 51, 204);">'Libraries',</span><span style="color: rgb(204, 51, 204);">'Loaders',</span><span style="color: rgb(204, 51, 204);">'iLoad_ini'</span> )</pre>
    and a local copy (which overrides the default) is stored in<br>
    <pre style="margin-left: 40px; color: rgb(51, 102, 255);">prefdir</pre>
    when executing<br>
    <pre style="margin-left: 40px;">&gt;&gt; <span style="color: rgb(51, 102, 255);">iLoad</span>(<span style="color: rgb(204, 51, 204);"></span><span style="color: rgb(204, 51, 204);">'save'</span>);<br><span style="font-style: italic;">% Saved iLoad configuration into /home/farhi/.matlab/R2015a/iLoad.ini</span> <span style="color: rgb(255, 0, 0);">&lt;- this is prefdir</span><br></pre>
    This is where you may add your own customized format definitions.
    Deleting this file will revert to the default configuration.<br>
    <pre style="margin-left: 40px;">&gt;&gt; <span style="color: rgb(51, 102, 255);">delete</span>([ <span style="color: rgb(51, 102, 255);">prefdir </span><span style="color: rgb(204, 51, 204);"><span style="color: rgb(51, 102, 255);">filesep</span> 'iLoad_ini.m'<span style="color: rgb(0, 0, 0);"> ]</span></span>);<br></pre>
    Last, the <span style="font-style: italic;">config.UseSystemDialogs</span>
    field of the <span style="font-style: italic;">iLoad</span>
    configuration can be set to<span style="color: rgb(204, 51, 204);">
      'yes' </span>to use the native Matlab/Java file selector, or to<span
      style="color: rgb(204, 51, 204);"> 'no' </span>to use<a
      href="../Loaders/doc/uigetfiles.html"> uigetfiles</a>. The
    config.MeX field configures if C/Fortran external interfaces
    (looktxt, cif2hkl) should be use as MeX or as separate executable
    files.<br>
    <br>
    To update a configuration, send it to iLoad:<br>
    <pre style="margin-left: 40px;">&gt;&gt; config = <span style="color: rgb(51, 102, 255);">iLoad</span>(<span style="color: rgb(204, 51, 204);"></span><span style="color: rgb(204, 51, 204);">'config'</span>); <span style="font-style: italic;">% retrieve the iLoad configuration and file loaders</span> (from cache)<br>&gt;&gt; <span style="color: rgb(51, 102, 255);">iLoad</span>(<span style="color: rgb(204, 51, 204);"></span><span style="color: rgb(204, 51, 204);">'save'</span>, config);</pre>
    <h4><a class="mozTocH4" name="mozTocId968211"></a>iLoad
      configuration structure</h4>
    Each format <span style="font-style: italic;">'loaders'</span>
    entry is a structure with members:<br>
    <ul>
      <li><span style="font-weight: bold;">loader.description</span>: a
        description of the format<br>
      </li>
      <li><span style="font-weight: bold;">loader.read</span>: the
        function used to read the file and return a structure or
        numerical array: <span style="font-style: italic;">data=method(filename)</span><br>
      </li>
      <li><span style="font-weight: bold;">loader.ext</span>: a
        single file extension, or a cell string of file extensions<br>
      </li>
      <li><span style="font-weight: bold;">loader.patterns</span>: a
        cell string of patterns to search in text headers (less than 10%
        of binary data in the first 10 kb) [optional]</li>
      <li><span style="font-weight: bold;">loader.options</span>:
        additional options to be passed to the loader.read. A single
        string is catenated after the file name, a cell array is sent as
        additional arguments to the method. [optional]</li>
      <li><span style="font-weight: bold;">loader.callback</span>: a
        script which handles iData commands to shape the final object, <span
          style="font-style: italic;">id=loader.callback(id)</span>
        [optional]<br>
      </li>
    </ul>
    Such entries can be added to each reader and be returned when
    requested for 'identify', or entered explicitly in the <a
      href="../Loaders/iLoad_ini.m">iLoad_ini</a> file.<br>
    <br>
    Let's details one of the <a href="../Loaders/iLoad_ini.m">iLoad_ini</a><span
      style="font-weight: bold;"></span> entry for INX files.<br>
    <br>
    <table style="text-align: left; width: 70%;" border="1"
      cellpadding="2" cellspacing="2">
      <tbody>
        <tr>
          <td style="vertical-align: top;">
            <pre><span style="color: rgb(204, 51, 204);">format14</span>.description       ='INX tof data';<br><span style="color: rgb(204, 51, 204);">format14</span>.ext  ='inx';<br><span style="color: rgb(204, 51, 204);">format14</span>.patterns   ={'INX'};<br><span style="color: rgb(204, 51, 204);">format14</span>.read     ='looktxt';<br><span style="color: rgb(204, 51, 204);">format14</span>.options    ='--headers --fortran  --catenate --fast --comment=NULL';<br><span style="color: rgb(204, 51, 204);">format14</span>.callback='load_ill_inx';<span style="color: rgb(204, 51, 204);"></span><br><span style="color: rgb(204, 51, 204);"></span><br><br>(...)<br><br>config.loaders =  { format1, format2, format3, format4, format5, format6, ...<br>	       format7, format8, format9, format10, format11, format12, format13, <span style="color: rgb(204, 51, 204);">format14, </span>format15 };<br></pre>
          </td>
        </tr>
      </tbody>
    </table>
    <br>
    Each format is a structure.<br>
    The <span style="font-weight: bold;">name</span> field gives an
    explicit description of the format (human readable). The <span
      style="font-weight: bold;">extension</span> <span style="color:
      rgb(204, 51, 204);">'inx'</span> indicates which string should
    match the file extension so that this format is selected for
    automatic importation. An other way to select the importer is by
    mean of pattern search in the file header content (by default the
    first 10 kb of text). The list of one or more patterns is given in
    the <span style="font-weight: bold;">patterns</span> field (as a <span
      style="font-style: italic;">cellstr, </span>here {<span
      style="color: rgb(204, 51, 204);">'INX'</span>}). The <span
      style="font-weight: bold;">method</span> field is the name of the
    function to read the file. It takes as input a string, the file
    name, and should preferably return a structure or numerical array.
    In this example, the <a href="../Loaders/doc/looktxt.html">looktxt</a>
    method is used with syntax<br>
    <pre style="margin-left: 40px;">struct = <span style="color: rgb(51, 102, 255);">looktxt</span>(filename)</pre>
    The <span style="font-weight: bold;">options</span> field provides
    additional options that should be sent to the method. When given as
    a single string, these options are appended to the filename before
    being sent to the method, e.g.<br>
    <pre style="margin-left: 40px;">struct = <span style="color: rgb(51, 102, 255);">looktxt</span>([ filename <span style="color: rgb(204, 51, 204);">options</span> ])</pre>
    When given as a cell, they are passed as additional input arguments
    to the method, e.g.<br>
    <pre style="margin-left: 40px;">struct=method(filename, options{1}, options{2}, ...)</pre>
    The structure obtained from the method is then converted into an <a
      href="iData.html">iData</a> object when called from the iData or
    iData/load method. In these cases, the <span style="font-weight:
      bold;">postprocess</span> field is used so that the returned <a
      href="iData.html">iData</a> object is<br>
    <pre style="margin-left: 40px;">object =<span style="color: rgb(204, 51, 204);"> postprocess(</span> <span style="color: rgb(51, 102, 255);">iData(</span> <span style="color: rgb(204, 51, 204);">method</span>(filename, options...) <span style="color: rgb(51, 102, 255);">)</span> <span style="color: rgb(204, 51, 204);">)</span></pre>
    The post-process is a script that takes as input an <span
      style="font-style: italic;">iData</span> object, and returns a
    possibly modified object (or an array of objects). This is where
    Signal, Axes, Aliases and metadata are re-arranged in the object.
    The post-process scripts are store in the<span style="font-style:
      italic;"> Loaders/postprocess</span> directory, and use a '<span
      style="font-style: italic;">load_&lt;format&gt;</span>' function
    naming convention for clarity. When missing, the default Signal and
    axes definitions will be used.<br>
    <br>
    The last step required for storing a new data format is to add the
    format definition to the<span style="font-weight: bold;">
      config.loaders</span> field in the <a
      href="../Loaders/iLoad_ini.m">iLoad_ini</a><span
      style="font-weight: bold;"></span> file. Once done, you may
    re-read the configuration file to update the list of known format<br>
    <pre style="margin-left: 40px;">&gt;&gt; <span style="color: rgb(51, 102, 255);">iLoad</span>(<span style="color: rgb(204, 51, 204);"></span><span style="color: rgb(204, 51, 204);">'force load config'</span>); <span style="font-style: italic;">% force to re-read the configuration files</span></pre>
    <h4><a class="mozTocH4" name="mozTocId120998"></a>In short:
      procedure to add a new data format</h4>
    <ol>
      <li>Start by getting the documentation about the new data format
        you wish to implement. This gives the format <span
          style="font-weight: bold;">name</span> and the <span
          style="font-weight: bold;">extension</span>.<br>
      </li>
      <li>Then write a function (locally or in <span style="color:
          rgb(51, 102, 255);">ifitpath/Loaders</span>) that takes as
        input a filename and returns the file content as a structure.
        This is where you will open the file, access its guts, and
        return something (or empty/error if this fails). This is your <span
          style="font-weight: bold;">method</span>.<br>
      </li>
      <li>Edit the <span style="font-style: italic;">iLoad_ini </span>file
































        from <span style="color: rgb(51, 102, 255);">prefdir</span> or
        <span style="color: rgb(51, 102, 255);">ifitpath/Loaders</span>.</li>
      <li>Create a new structure (which you may name as you wish) and
        set the name (description), method, and extension fields.</li>
      <li>Optionally define some <span style="font-weight: bold;">patterns</span>
        to search, to complement the extension (as a list of words).</li>
      <li>Optionally write a post-process script and preferably place it
        in the <span style="color: rgb(51, 102, 255);">ifitpath/Loaders/postprocess</span>.
      </li>
      <li>Add the new structure to the <span style="font-weight: bold;">config.loaders</span>
        list (cell) at the end of the <a
          href="../Libraries/Loaders/iLoad_ini.m">iLoad_ini</a><span
          style="font-weight: bold;"></span> file.</li>
      <li>Save the file, and optionally re-read it with <span
          style="font-style: italic;">iLoad('force load config')</span>.</li>
      <li>Send me [farhi (at) ill.fr] the method/postprocess and
        structure information so that I can contribute your work to the
        package.<br>
      </li>
    </ol>
    <br>
    <hr style="width: 100%; height: 2px;">
    <div style="text-align: center;">
      <div style="text-align: center;"><span style="font-style: italic;">E.
Farhi






          - iFit/Loaders - </span><span style="font-style: italic;">
          $Date$ $Revision$ $Author$</span><span style="font-style:
          italic;"> </span>- back to <a href="index.html">Main iFit
          Page </a></div>
    </div>
  </body>
</html>
